unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    SuccLabel: TLabel;
    GroupBox1: TGroupBox;
    ReadButton: TButton;
    ReqEdit: TEdit;
    ValueEdit: TEdit;
    IndexEdit: TEdit;
    ReadLenEdit: TEdit;
    ReadDataEdit: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    UpDown1: TUpDown;
    Label5: TLabel;
    GroupBox2: TGroupBox;
    WriteButton: TButton;
    WriteDataEdit: TEdit;
    WriteLenLabel: TLabel;
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label6: TLabel;
    Edit3: TEdit;
    Label7: TLabel;
    UpDown2: TUpDown;
    Label8: TLabel;
    GroupBox3: TGroupBox;
    AmplitudeEdit: TEdit;
    BiasEdit: TEdit;
    RampDurationEdit: TEdit;
    HoldDurationEdit: TEdit;
    OuttroDurationEdit: TEdit;
    DACNumEdit: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    FriendlyButton: TButton;
    FriendlyEdit: TEdit;
    FriendlyLen: TLabel;
    Button1: TButton;
    InitTickRateButton: TButton;
    HzEdit: TEdit;
    Hz: TLabel;
    start0: TButton;
    start1: TButton;
    start2: TButton;
    stop0: TButton;
    stop1: TButton;
    stop2: TButton;
    Button2: TButton;
    procedure ReadButtonClick(Sender: TObject);
    procedure WriteButtonClick(Sender: TObject);
    procedure WriteDataEditChange(Sender: TObject);
    procedure FriendlyButtonClick(Sender: TObject);
    procedure FriendlyEditChange(Sender: TObject);
    procedure aFriendlyEditChanged(Sender: TObject);
    procedure startDACClick(Sender: TObject);
    procedure stopDACClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InitTickRateButtonClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
  AIOUSB;
{$R *.DFM}

var
  dacnum, bias, amp, up, hold: word;
  down:byte;


function ErrorText(ErrorCode: LongWord): String;
var
  WindowsError: PChar;

begin
  FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER + FORMAT_MESSAGE_FROM_SYSTEM, nil, ErrorCode, 0, PChar(@WindowsError), 0, nil);
  Result := WindowsError;
  LocalFree(Cardinal(WindowsError));
end;

function NybbleToHex(N: Byte): Char;
begin
  N := N and $F;
  if N < 10 then
    Result := Char(Byte('0') + N)
  else
    Result := Char(Byte('A') - 10 + N)
  ;
end;

function StrToHex(Text: String): String;
var
  I: Integer;

begin
  SetString(Result, nil, Length(Text) * 2);
  for I := 1 to Length(Text) do begin
    Result[I * 2 - 1] := NybbleToHex(Byte(Text[I]) shr 4);
    Result[I * 2]     := NybbleToHex(Byte(Text[I])      );
  end;
end;

function StrToSpacedHex(Text: String): String;
var
  I: Integer;

begin
  SetString(Result, nil, Length(Text) * 3);
  for I := 1 to Length(Text) do begin
    Result[I * 3 - 2] := ' ';
    Result[I * 3 - 1] := NybbleToHex(Byte(Text[I]) shr 4);
    Result[I * 3]     := NybbleToHex(Byte(Text[I])      );
  end;
end;

function StringReplaceC(const S: String; const OldChar, NewChar: Char): String;
var
  I: Integer;

begin
  Result := S;
  for I := 1 to Length(Result) do
    if Result[I] = OldChar then
      Result[I] := NewChar
  ;
end;

function ValidateHexText(S: String): String;
var
  Content: TStringList;
  Buf: String;
  I, L: Integer;

begin
  S := StringReplaceC(S, ',', #13);
  S := StringReplaceC(S, ' ', #13);
  Content := TStringList.Create;
  try
    Content.Text := S;
    S := '';
    for I := Content.Count - 1 downto 0 do //Clear blank bytes and double delimiters
      if Length(Content[I]) = 0 then
        Content.Delete(I)
    ;
    L := Content.Count;
    SetString(Result, nil, L);
    for I := 0 to L - 1 do begin
      Buf := Content[I];
      Result[I + 1] := Char(StrToInt('$' + Buf));
    end;
  finally
    Content.Free;
  end;
end;

procedure TForm1.WriteDataEditChange(Sender: TObject);
begin
  try
    WriteLenLabel.Caption := IntToHex(Length(ValidateHexText(WriteDataEdit.Text)),2);
    WriteDataEdit.Color := clWindow;
    WriteDataEdit.Font.Color := clWindowText;
  except
    WriteLenLabel.Caption := '';
    WriteDataEdit.Color := $0000FF;
    WriteDataEdit.Font.Color := $FFFFFF;
  end;
end;

procedure TForm1.WriteButtonClick(Sender: TObject);
var
  I: longword;
  Buf: String;
  Status: LongWord;

begin
  I := diOnly;

  Buf := ValidateHexText(WriteDataEdit.Text);
  Status := GenericVendorWrite(I, StrToInt('$' + ReqEdit.Text), StrToInt('$' + ValueEdit.Text), StrToInt('$' + IndexEdit.Text), Length(Buf), PChar(Buf));
  if Status = ERROR_SUCCESS then begin
    SuccLabel.Caption := '';
    SuccLabel.Color := $00FF00;
  end
  else begin
    SuccLabel.Caption := IntToStr(Status) + ': ' + Trim(ErrorText(Status));
    SuccLabel.Color := $0000FF;
  end;
  //RestoreTime.Enabled := True;
  Buf := '';
end;

procedure TForm1.ReadButtonClick(Sender: TObject);
var
  I: longword;
  Buf: String;
  L: LongWord;
  Status: LongWord;

begin
  I := diOnly;

  L := StrToInt('$' + ReadLenEdit.Text);
  SetString(Buf, nil, L);
  Status := GenericVendorRead(I, StrToInt('$' + ReqEdit.Text), StrToInt('$' + ValueEdit.Text), StrToInt('$' + IndexEdit.Text), L, PChar(Buf));
  if Status = ERROR_SUCCESS then begin
    SuccLabel.Caption := '';
    SuccLabel.Color := $00FF00;
    SetLength(Buf, L);
    ReadDataEdit.Text := Trim(StrToSpacedHex(Buf));
    ReadLenEdit.Text := IntToHex(L,2);
  end
  else begin
    SuccLabel.Caption := IntToStr(Status) + ': ' + Trim(ErrorText(Status));
    SuccLabel.Color := $0000FF;
  end;
  //RestoreTime.Enabled := True;
  Buf := '';
end;


procedure TForm1.FriendlyButtonClick(Sender: TObject);
var
  I: longword;
  Buf: String;
  Status: LongWord;

begin
  I := diOnly;

  Buf := ValidateHexText(FriendlyEdit.Text);
  //  (sender as tbutton).tag == "0" for "load data only",
  //                          or "1" for "load data and output immediately"
  //                          or "TBD" for eventual trigger modes

  Status := GenericVendorWrite(I, $C6, (sender as tbutton).tag, StrToInt(DACNumEdit.Text), Length(Buf), PChar(Buf));
  if Status = ERROR_SUCCESS then begin
    SuccLabel.Caption := '';
    SuccLabel.Color := $00FF00;
  end
  else begin
    SuccLabel.Caption := IntToStr(Status) + ': ' + Trim(ErrorText(Status));
    SuccLabel.Color := $0000FF;
  end;
  //RestoreTime.Enabled := True;
  Buf := '';
end;

procedure TForm1.FriendlyEditChange(Sender: TObject);
begin
  try
    FriendlyLen.Caption := IntToHex(Length(ValidateHexText(FriendlyEdit.Text)),2);
    FriendlyEdit.Color := clWindow;
    FriendlyEdit.Font.Color := clWindowText;
  except
    FriendlyLen.Caption := '';
    FriendlyEdit.Color := $0000FF;
    FriendlyEdit.Font.Color := $FFFFFF;
  end;
end;

function LO(w:word):byte;
begin
  result := w and $FF;
end;

function HI(w:word):byte;
begin
  result := (w shr 8) and $FF;
end;

procedure TForm1.aFriendlyEditChanged(Sender: TObject);
var buf:string;
begin
  dacnum := StrToInt(DACNumEdit.Text);
  bias := strtoint(BiasEdit.Text);
  amp := StrToInt(AmplitudeEdit.Text);
  up := StrToInt(RampDurationEdit.Text);
  hold := StrToInt(HoldDurationEdit.text);
  down := StrToInt(OuttroDurationEdit.text);

  SetLength(buf, 9);
  buf[1] := char(LO(bias));
  buf[2] := char(HI(bias));

  buf[3] := char(LO(amp));
  buf[4] := char(HI(amp));

  buf[5] := char(LO(up));
  buf[6] := char(HI(up));

  buf[7] := char(LO(hold));
  buf[8] := char(HI(hold));

  buf[9] := char(down);



  FriendlyEdit.text := StrToSpacedHex(buf);

end;

procedure TForm1.startDACClick(Sender: TObject);
begin
  GenericVendorWrite(diOnly, $C6, $0001, (sender as TButton).tag, 0, nil);
end;

procedure TForm1.stopDACClick(Sender: TObject);
begin
  GenericVendorWrite(diOnly, $C6, $0002, (sender as TButton).tag, 0, nil);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  aFriendlyEditChanged(self );
  DACSetBoardRange(diOnly, 0);
end;

procedure TForm1.InitTickRateButtonClick(Sender: TObject);
  var
    status: longword;
    divisor:word;
begin
  divisor := 4000000  div StrToInt(HzEdit.Text);
  status := GenericVendorWrite(diOnly, $C6, $8000, divisor, 0, nil);
  //status := GenericVendorWrite(diOnly, $C6, $8000,  StrToInt('$' + HzEdit.Text), 0, nil);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  GenericVendorWrite(diOnly, $C6, $0001, $FF, 0, nil);
end;

end.
